From 67337314ec2988384a1175b8565f35a4fe9d4c63 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jan 21 2016 20:17:52 +0000
Subject: [PATCH 257/1001] Test the cobweb widget.


---

diff --git a/hubs/models.py b/hubs/models.py
index 79a481f..f56fc0d 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -133,13 +133,16 @@ class Hub(BASE):
     avatar = sa.Column(sa.String(256), default=placekitten)
     header_img = sa.Column(sa.String(256), default=randomheader)
 
+    # Timestamps about various kinds of "freshness"
+    last_refreshed = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
+    last_accessed = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
+    last_edited = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
+
     #fas_group = sa.Column(sa.String(32), nullable=False)
 
     @property
     def days_idle(self):
-        # TODO -- implement calculating time since this hub was active
-        import random
-        return random.randint(0, 356)
+        return (datetime.datetime.utcnow() - self.last_refreshed).days
 
     @property
     def activity_class(self):
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index 2238a4c..0402c4f 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -1,4 +1,5 @@
 import json
+from datetime import datetime, timedelta
 from os.path import dirname
 import unittest
 
@@ -50,9 +51,18 @@ class WidgetTest(unittest.TestCase):
         )
         hub.widgets.append(widget)
 
-        for team in ['i18n', 'infra']:
+        for team in ['i18n', 'infra', 'old']:
             hub = hubs.models.Hub(name=team, summary="the %s team" % team)
+            if hub.name == 'old':
+                hub.last_refreshed = datetime.utcnow() - timedelta(days=100)
+                hub.last_updated = datetime.utcnow() - timedelta(days=200)
+
             hubs.app.session.add(hub)
+            widget = hubs.models.Widget(
+                plugin='cobwebs',
+                index=10,
+            )
+            hub.widgets.append(widget)
 
 
     # TODO - test that it is in the registry
@@ -60,6 +70,8 @@ class WidgetTest(unittest.TestCase):
 
     def widget_instance(self, hubname, plugin):
         hub = hubs.models.Hub.by_name(self.session, hubname)
+        if not hub:
+            raise ValueError("No such hub %r" % hubname)
         for widget in hub.widgets:
             if widget.plugin == plugin:
                 return widget
diff --git a/hubs/tests/test_widgets/test_cobwebs.py b/hubs/tests/test_widgets/test_cobwebs.py
new file mode 100644
index 0000000..d0f32ae
--- /dev/null
+++ b/hubs/tests/test_widgets/test_cobwebs.py
@@ -0,0 +1,37 @@
+import json
+
+import hubs.tests.test_widgets
+
+
+class TestBadges(hubs.tests.test_widgets.WidgetTest):
+    plugin = 'cobwebs'  # The name in hubs.widgets.registry
+
+    def test_data_old(self):
+        widget = self.widget_instance('old', self.plugin)
+        response = self.app.get('/old/%i/json/' % widget.idx)
+        assert response.status_code == 200, response.status_code
+        data = json.loads(response.data)
+        self.assertDictEqual(data['data'], {
+            u'days': 100,
+            u'old': True,
+            u'archived': False,
+            u'icon': u'/static/img/cobweb.png',
+            u'source_url': u'/source/cobwebs/',
+            u'then': '3 months ago',
+            u'widget_url': u'/old/44/',
+        })
+
+    def test_data_young(self):
+        widget = self.widget_instance('infra', self.plugin)
+        response = self.app.get('/infra/%i/json/' % widget.idx)
+        assert response.status_code == 200, response.status_code
+        data = json.loads(response.data)
+        self.assertDictEqual(data['data'], {
+            u'days': 0,
+            u'old': False,
+            u'archived': False,
+            u'icon': u'/static/img/cobweb.png',
+            u'source_url': u'/source/cobwebs/',
+            u'then': u'just now',
+            u'widget_url': u'/infra/43/',
+        })
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 995125c..f1f84cb 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -1,4 +1,5 @@
 import collections
+import datetime
 import functools
 import hashlib
 import json
@@ -66,7 +67,13 @@ def smartcache(func):
 
 def invalidate_cache(widget, *args, **kwargs):
     key = cache_key_generator(widget, *args, **kwargs)
-    log.debug("Deleting cache key %s", key)
+
+    if not cache.get(key, ignore_expiration=True):
+        log.debug("Not deleting cache key %s.  It is absent.", key)
+        return
+
+    widget.hub.last_refreshed = datetime.datetime.utcnow()
+    log.debug("Deleting cache key %s.", key)
     cache.delete(key)
 
 

